target bdm /dev/bdmcf0
x 0x00000000  
x 
x 

define addresses

set $myipsbar = 0x40000001
set $myrambar = $myipsbar -1 + 0x008    


# Pll
set $myclocksyncr = $myipsbar -1 + 0x120000    
set $myclocksynsr = $myipsbar -1 + 0x120002    

# Uart
set $mygpio_puapar = $myipsbar -1 + 0x10005C    

# Watchdog Timer Module (WTM)
set $wcr          = $myipsbar + 0x140000
set $wmr          = $myipsbar + 0x140002
set $wcntr        = $myipsbar + 0x140004
set $wsr          = $myipsbar + 0x140006


# CS0-6
set $myuart0_umr   = $myipsbar -1 + 0x200    
set $myuart0_ucsr  = $myipsbar -1 + 0x204    
set $myuart0_ucr   = $myipsbar -1 + 0x208    
set $myuart0_utb   = $myipsbar -1 + 0x20c    
set $myuart0_urb   = $myipsbar -1 + 0x20c    
set $myuart0_uimr  = $myipsbar -1 + 0x214    
set $myuart0_ubg1  = $myipsbar -1 + 0x218    
set $myuart0_ubg2  = $myipsbar -1 + 0x21c    

set $mycs0_csar   = $myipsbar -1 + 0x80    
set $mycs0_csmr   = $myipsbar -1 + 0x84    
set $mycs0_cscr   = $myipsbar -1 + 0x8A    

set $mycs1_csar   = $myipsbar -1 + 0x8C    
set $mycs1_csmr   = $myipsbar -1 + 0x90    
set $mycs1_cscr   = $myipsbar -1 + 0x96    

set $mycs2_csar   = $myipsbar -1 + 0x98    
set $mycs2_csmr   = $myipsbar -1 + 0x9C    
set $mycs2_cscr   = $myipsbar -1 + 0xA2    

set $mycs3_csar   = $myipsbar -1 + 0xA4    
set $mycs3_csmr   = $myipsbar -1 + 0xA8    
set $mycs3_cscr   = $myipsbar -1 + 0xAE    

set $mycs4_csar   = $myipsbar -1 + 0xB0    
set $mycs4_csmr   = $myipsbar -1 + 0xB4    
set $mycs4_cscr   = $myipsbar -1 + 0xBA    

set $mycs5_csar   = $myipsbar -1 + 0xBC    
set $mycs5_csmr   = $myipsbar -1 + 0xC0    
set $mycs5_cscr   = $myipsbar -1 + 0xC6    

set $mycs6_csar   = $myipsbar -1 + 0xC8    
set $mycs6_csmr   = $myipsbar -1 + 0xCC    
set $mycs6_cscr   = $myipsbar -1 + 0xD2   


#PIT 1
set $pit1base = $myipsbar -1 + 0x150000
set $pcsr1    = $pit1base    
set $pmr1     = $pit1base + 0x02   
set $pcntr1   = $pit1base + 0x04



#sdram
set $mysdramc_dcr     = $myipsbar -1 + 0x40    
set $mysdramc_dacr0   = $myipsbar -1 + 0x48
set $mysdramc_dmr0    = $myipsbar -1 + 0x4C
set $mysdramc_dacr1   = $myipsbar -1 + 0x50
set $mysdramc_dmr1    = $myipsbar -1 + 0x54

# GPIO
set $mypbcdpar = $myipsbar -1 + 0x100050    
set $mypjpar  = $myipsbar -1 + 0x100054 
set $mypuapar  = $myipsbar -1 + 0x10005C
set $mypepar = $myipsbar -1 + 0x100052   
set $myportep = $myipsbar -1 + 0x10002c  
set $myclre = $myipsbar -1 + 0x100040   
set $myddre = $myipsbar -1 + 0x100018  
set $mypehlpar  = $myipsbar -1 + 0x100058   
set $mygpio_paspar = $myipsbar -1 + 0x100056


#CAN

set $mycanmcr     = $myipsbar -1 + 0x1C0000   
set $mycanctrl0   = $myipsbar -1 + 0x1C0006   
set $mycanctrl1   = $myipsbar -1 + 0x1C0007   
set $mycanpresdiv = $myipsbar -1 + 0x1C0008
set $mycanctrl2   = $myipsbar -1 + 0x1C0009   

set $mycanmb0ctrl = $myipsbar -1 + 0x1C0080
set $mycanmb0idh  = $myipsbar -1 + 0x1C0082
set $mycanmb0idl  = $myipsbar -1 + 0x1C0084

set $mycanmb1ctrl = $myipsbar -1 + 0x1C0090
set $mycanmb1idh  = $myipsbar -1 + 0x1C0092
set $mycanmb1idl  = $myipsbar -1 + 0x1C0094
   
set $mycanmb2ctrl = $myipsbar -1 + 0x1C00A0
set $mycanmb2idh  = $myipsbar -1 + 0x1C00A2
set $mycanmb2idl  = $myipsbar -1 + 0x1C00A4
   
set $mycanmb3ctrl = $myipsbar -1 + 0x1C00B0
set $mycanmb3idh  = $myipsbar -1 + 0x1C00B2
set $mycanmb3idl  = $myipsbar -1 + 0x1C00B4
   
set $mycanmb4ctrl = $myipsbar -1 + 0x1C00C0
set $mycanmb4idh  = $myipsbar -1 + 0x1C00C2
set $mycanmb4idl  = $myipsbar -1 + 0x1C00C4
   
set $mycanmb5ctrl = $myipsbar -1 + 0x1C00D0
set $mycanmb5idh  = $myipsbar -1 + 0x1C00D2
set $mycanmb5idl  = $myipsbar -1 + 0x1C00D4
   
set $mycanmb6ctrl = $myipsbar -1 + 0x1C00E0
set $mycanmb6idh  = $myipsbar -1 + 0x1C00E2
set $mycanmb6idl  = $myipsbar -1 + 0x1C00E4
   
set $mycanmb7ctrl = $myipsbar -1 + 0x1C00F0
set $mycanmb7idh  = $myipsbar -1 + 0x1C00F2
set $mycanmb7idl  = $myipsbar -1 + 0x1C00F4
   
set $mycanmb8ctrl = $myipsbar -1 + 0x1C0100
set $mycanmb8idh  = $myipsbar -1 + 0x1C0102
set $mycanmb8idl  = $myipsbar -1 + 0x1C0104
   
set $mycanmb9ctrl = $myipsbar -1 + 0x1C0110
set $mycanmb9idh  = $myipsbar -1 + 0x1C0112
set $mycanmb9idl  = $myipsbar -1 + 0x1C0114

set $mycanmb10ctrl = $myipsbar -1 + 0x1C0120
set $mycanmb10idh  = $myipsbar -1 + 0x1C0122
set $mycanmb10idl  = $myipsbar -1 + 0x1C0124

set $mycanmb11ctrl = $myipsbar -1 + 0x1C0130
set $mycanmb11idh  = $myipsbar -1 + 0x1C0132
set $mycanmb11idl  = $myipsbar -1 + 0x1C0134
   
set $mycanmb12ctrl = $myipsbar -1 + 0x1C0140
set $mycanmb12idh  = $myipsbar -1 + 0x1C0142
set $mycanmb12idl  = $myipsbar -1 + 0x1C0144

set $mycanmb13ctrl = $myipsbar -1 + 0x1C0150
set $mycanmb13idh  = $myipsbar -1 + 0x1C0152
set $mycanmb13idl  = $myipsbar -1 + 0x1C0154

set $mycanmb14ctrl = $myipsbar -1 + 0x1C0160
set $mycanmb14idh  = $myipsbar -1 + 0x1C0162
set $mycanmb14idl  = $myipsbar -1 + 0x1C0164

set $mycanmb15ctrl = $myipsbar -1 + 0x1C0170
set $mycanmb15idh  = $myipsbar -1 + 0x1C0172
set $mycanmb15idl  = $myipsbar -1 + 0x1C0174

set $mycanrxgmask  = $myipsbar -1 + 0x1C0010


#Flash (CPU address)

set $flashbar = 0xc04


# end addresses
end


define setup_can

# FRZ 0x4000 HALT 0x1000 SELFWAKE  0x40
set *(unsigned short *)$mycanmcr = 0x5040

#RXMODE =0x04
set *(unsigned char *)$mycanctrl0 = 0x04

#LOM 0x08
set *(unsigned char *)$mycanctrl1 = 0x08

set *(unsigned char *)$mycanpresdiv = 0x83

set *(unsigned short *)$mycanmb0ctrl = 0x0088
set *(unsigned short *)$mycanmb1ctrl = 0x0000
set *(unsigned short *)$mycanmb2ctrl = 0x0088
set *(unsigned short *)$mycanmb3ctrl = 0x0088
set *(unsigned short *)$mycanmb4ctrl = 0x0088
set *(unsigned short *)$mycanmb5ctrl = 0x0088
set *(unsigned short *)$mycanmb6ctrl = 0x0088
set *(unsigned short *)$mycanmb7ctrl = 0x0088
set *(unsigned short *)$mycanmb8ctrl = 0x0088
set *(unsigned short *)$mycanmb9ctrl = 0x0000
set *(unsigned short *)$mycanmb10ctrl = 0x0000
set *(unsigned short *)$mycanmb11ctrl = 0x0000
set *(unsigned short *)$mycanmb12ctrl = 0x0000
set *(unsigned short *)$mycanmb13ctrl = 0x0000
set *(unsigned short *)$mycanmb14ctrl = 0x0000
set *(unsigned short *)$mycanmb15ctrl = 0x0000


# FRZ 0x4000 HALT 0x1000 SELFWAKE  0x40
set *(unsigned long *)$mycanrxgmask = 0xFFE00000

# FRZ 0x4000 HALT SELFWAKE  0x40
set *(unsigned short *)$mycanmcr = 0x4040


end

define setup_gpio

set *(unsigned char *)$mypbcdpar=0xC0
set *(unsigned char *)$mypuapar=0x0F
set *(unsigned char *)$mypjpar=0xFF

#new addition, turn off port control lines

set *(unsigned short *)$mypepar=0x4100
set *(unsigned char *)$myddre|=0x1
set *(unsigned char *)$myclre&=0x1


end

define setup_iram
####### set up internal sram ####################
set *$myrambar = 0x20000200

set *0x20000000=0x12345678  
set *0x20000000=0x55aa55aa  
set *0x20000004=0xaa55aa55  
x 0x20000000  
x 0x20000004
# end setup_iram
end


####### set up pll ####################
define setup_pll
#set $myclocksyncr = $myipsbar -1 + 0x120000    
#set $myclocksynsr = $myipsbar -1 + 0x120002    

set *(unsigned short *)$myclocksyncr =  (((2)&0x0007)<<12)  
   
while ((*$myclocksynsr &  0x08000000) == 0 )
	set $foo = 0
end

# end setup_pll
end

######### set up uart 0 ###########################

define setup_uart0

#set $mygpio_puapar = $myipsbar -1 + 0x10005C    
#set $myuart0_umr   = $myipsbar -1 + 0x200    
#set $myuart0_ucsr  = $myipsbar -1 + 0x204    
#set $myuart0_ucr   = $myipsbar -1 + 0x208    
#set $myuart0_utb   = $myipsbar -1 + 0x20c    
#set $myuart0_urb   = $myipsbar -1 + 0x20c    
#set $myuart0_uimr  = $myipsbar -1 + 0x214    
#set $myuart0_ubg1  = $myipsbar -1 + 0x218    
#set $myuart0_ubg2  = $myipsbar -1 + 0x21c    

set *(unsigned char *)$mygpio_puapar=0x0f
#reset tx
set *(unsigned char *)$myuart0_ucr=0x30
#reset rx
set *(unsigned char *)$myuart0_ucr=0x20
#reset mr
set *(unsigned char *)$myuart0_ucr=0x10

# no parity 8 bits per char
set *(unsigned char *)$myuart0_umr=0x13

# no echo or loopback 1 stop
set *(unsigned char *)$myuart0_umr=0x07
 
# rx tx baud by timer
set *(unsigned char *)$myuart0_ucsr=0xdd

# mask all interrupts
set *(unsigned char *)$myuart0_uimr=0x0

set $uast_brg = (64000000/(19200 * 32))

# set up baud rates
set *(unsigned char *)$myuart0_ubg1=($uast_brg & 0xFF00) >> 8
set *(unsigned char *)$myuart0_ubg2=($uast_brg & 0x00FF)

# enable tx rx
set *(unsigned char *)$myuart0_ucr=0x5

#end uart0
end

define send_chars
# send chars ABCD
set *(unsigned char *)$myuart0_utb=0x41
set *(unsigned char *)$myuart0_utb=0x42
set *(unsigned char *)$myuart0_utb=0x43
set *(unsigned char *)$myuart0_utb=0x44
#end send_chars
end


define setup_cs
######### set up CS (just fsram and flash)###########################

#set $mycs0_csar   = $myipsbar -1 + 0x80    
#set $mycs0_csmr   = $myipsbar -1 + 0x84    
#set $mycs0_cscr   = $myipsbar -1 + 0x8A    

#set $mycs1_csar   = $myipsbar -1 + 0x8C    
#set $mycs1_csmr   = $myipsbar -1 + 0x90    
#set $mycs1_cscr   = $myipsbar -1 + 0x96    

#set $mycs2_csar   = $myipsbar -1 + 0x98    
#set $mycs2_csmr   = $myipsbar -1 + 0x9C    
#set $mycs2_cscr   = $myipsbar -1 + 0xA2    

#set $mycs3_csar   = $myipsbar -1 + 0xA4    
#set $mycs3_csmr   = $myipsbar -1 + 0xA8    
#set $mycs3_cscr   = $myipsbar -1 + 0xAE    

#set $mycs4_csar   = $myipsbar -1 + 0xB0    
#set $mycs4_csmr   = $myipsbar -1 + 0xB4    
#set $mycs4_cscr   = $myipsbar -1 + 0xBA    

#set $mycs5_csar   = $myipsbar -1 + 0xBC    
#set $mycs5_csmr   = $myipsbar -1 + 0xC0    
#set $mycs5_cscr   = $myipsbar -1 + 0xC6    

#set $mycs6_csar   = $myipsbar -1 + 0xC8    
#set $mycs6_csmr   = $myipsbar -1 + 0xCC    
#set $mycs6_cscr   = $myipsbar -1 + 0xD2   




#CPLD decoding at 0x3000_0000 1 WS ??
set *(unsigned short *)$mycs3_csar=0x3000
set *(unsigned short *)$mycs3_cscr=0x0100
set *(unsigned long *) $mycs3_csmr=0x00070001

if 1
# external flash at 0
set *(unsigned short *)$mycs0_csar=0xFFE0
set *(unsigned short *)$mycs0_cscr=0x1980
set *(unsigned long *) $mycs0_csmr=0x001f0001
end

#end setup_cs
end


#############################################
# Initialize the Watchdog Timer
#
define mcf5282_wtm_init

# disable watchdog
set *(unsigned short *)$wcr=0x0000

end

#############################################


####################################################
define setup_sdram
######### set up SDRAM ###########################

set $mysdramc_dcr     = $myipsbar -1 + 0x40    
set $mysdramc_dacr0   = $myipsbar -1 + 0x48
set $mysdramc_dmr0    = $myipsbar -1 + 0x4C
set $mysdramc_dacr1   = $myipsbar -1 + 0x50
set $mysdramc_dmr1    = $myipsbar -1 + 0x54

set $foo = 0

set * $mysdramc_dcr   =0x023c0000
set * $mysdramc_dacr0 = 0x00001300
#set * $mysdramc_dacr0 = 0xff881300


set * $mysdramc_dmr0 =0x00fc0001
set * $mysdramc_dacr0 |= (0x00000008)  

# init precharge
set *(0x00000000) = 0xA5A59696

#set *(0xff880000) = 0xA5A59696

# wait
   while ($foo < 20000)
	set $foo += 1
   end

# set RE  in dacr
   set * $mysdramc_dacr0 |= \
	(0x00008000)  
   
  # issue IMRS
   set * $mysdramc_dacr0 |= \
	(0x00000040)  
	
# wait for 8 auto refresh
   while ($foo < 20000)
	set $foo += 1
   end	
   
   # set mode
   set *(0x00000000 + 0x400 ) = 0xA5A59696
   #set *(0xff880000 + 0x400 ) = 0xA5A59696

   #set *(0xff880000) = 0x12345678
   #set *(0xff880004) = 0x87654321
   #x 0xff880000
   #x 0xff880004
   
   set *(0x00000000) = 0x12345678
   set *(0x00000004) = 0x87654321
   x 0x00000000
   x 0x00000004
   
   
#end setup_sdram
end


######### set up uart 2 ###########################

define setup_uart2

    
set $myuart2_umr   = $myipsbar -1 + 0x280    
set $myuart2_ucsr  = $myipsbar -1 + 0x284    
set $myuart2_ucr   = $myipsbar -1 + 0x288    
set $myuart2_utb   = $myipsbar -1 + 0x28c    
set $myuart2_urb   = $myipsbar -1 + 0x28c    
set $myuart2_uimr  = $myipsbar -1 + 0x294    
set $myuart2_ubg1  = $myipsbar -1 + 0x298    
set $myuart2_ubg2  = $myipsbar -1 + 0x29c    


set *(unsigned short *)$mygpio_paspar=0x0f0a
#reset tx
set *(unsigned char *)$myuart2_ucr=0x30
#reset rx
set *(unsigned char *)$myuart2_ucr=0x20
#reset mr
set *(unsigned char *)$myuart2_ucr=0x10

# no parity 8 bits per char
set *(unsigned char *)$myuart2_umr=0x13

# no echo or loopback 1 stop
set *(unsigned char *)$myuart2_umr=0x07
 
# rx tx baud by timer
set *(unsigned char *)$myuart2_ucsr=0xdd

# mask all interrupts
set *(unsigned char *)$myuart2_uimr=0x0

#set $uast_brg = (64000000/(19200 * 32))
set $uast_brg = (64000000/(115200 * 32))

# set up baud rates
set *(unsigned char *)$myuart2_ubg1=($uast_brg & 0xFF00) >> 8
set *(unsigned char *)$myuart2_ubg2=($uast_brg & 0x00FF)

# enable tx rx
set *(unsigned char *)$myuart2_ucr=0x5

#end setup_uart2
end

define send_chars2
# send chars
set *(unsigned char *)$myuart2_utb=0x41
set *(unsigned char *)$myuart2_utb=0x42
set *(unsigned char *)$myuart2_utb=0x43
set *(unsigned char *)$myuart2_utb=0x44
#end send_chars
end



######### dump uarts registers ###########################

define dump_uarts

x $mygpio_puapar    
x $myuart0_umr      
x $myuart0_ucsr   
x $myuart0_ucr   
x $myuart0_utb      
x $myuart0_urb       
x $myuart0_uimr      
x $myuart0_ubg1    
x $myuart0_ubg2 

x $mygpio_paspar    
x $myuart2_umr      
x $myuart2_ucsr   
x $myuart2_ucr   
x $myuart2_utb      
x $myuart2_urb       
x $myuart2_uimr      
x $myuart2_ubg1    
x $myuart2_ubg2      

end




##################################################################################
define load_kernel
######### load the kernel and it's symbols into memory ###########################
dir kernel_src/arch/m68knommu/kernel/
dir kernel_src/drivers/net/
dir kernel_src/arch/m68knommu/platform/5307/
dir kernel_src/arch/m68knommu/platform/5282/
dir kernel_src/arch/m68knommu/platform/5282/MOTOROLA/
#dir kernel_src/kernel/
dir kernel_src/arch/m68knommu/kernel/
dir kernel_src/init/
dir kernel_src/arch/m68knommu/mm/
dir kernel_src/fs
dir rtai/arch/m68knommu/
dir rtai/upscheduler/
dir rtai/fifos/
dir rtai/examples/

load
#end load_kernel
end


##################################################################################
define run_kernel
######### run the pre-loaded kernel #########################
set $pc = _start
b start_kernel
c
#end run_kernel
end

##################################################################################
define display_regs
display $a0
display $a1
display $a2
display $d0
display $d1
display $pc
display $sp
end



addresses
setup_gpio
setup_iram
setup_pll
setup_uart0
setup_uart2
setup_cs
setup_sdram
#setup_can
mcf5282_wtm_init










